"""
Django settings for homeetServer project.

Generated by 'django-admin startproject' using Django 3.2.5.

For more information on this file, see
https://docs.djangoproject.com/en/3.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.2/ref/settings/
"""

from pathlib import Path
import os

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'django-insecure-tu#08+u_t-%3y1_+ljd-%xaf-%15mgt0+kvak--&p*xm4=hd9&'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = ['207.154.252.64', '127.0.0.1', 'localhost', 'beta.homeet.styleru.org', '172.18.211.119',
                 'homeet.hse.ru', '51.250.31.120']

# Application definition
# SILENCED_SYSTEM_CHECKS = ['captcha.recaptcha_test_key_error']

INSTALLED_APPS = [
    'general.apps.GeneralConfig',
    'announcement.apps.AnnouncementConfig',
    'student.apps.StudentConfig',
    'realtor.apps.RealtorConfig',
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'mozilla_django_oidc',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

# MULTI_CAPTCHA_ADMIN = {
#     'engine': 'simple-captcha',
# }

ROOT_URLCONF = 'homeetServer.urls'

AUTH_USER_MODEL = 'general.Account'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [BASE_DIR / 'general/templates']
        ,
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'homeetServer.wsgi.application'


# Database
# https://docs.djangoproject.com/en/3.2/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.postgresql_psycopg2',
        'NAME': 'homeet',
        'USER': 'egorsavcuk',
        'PASSWORD': '23127890Es',
        'HOST': 'localhost',
        'PORT': '',
    }
}


# Password validation
# https://docs.djangoproject.com/en/3.2/ref/settings/#auth-password-validators

# AUTH_PASSWORD_VALIDATORS = [
#     {'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
#         'OPTIONS': {
#             'min_length': 8, }
#      },
#     {'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator', },
#     {'NAME': 'general.validators.NumberValidator', },
#     {'NAME': 'general.validators.UppercaseValidator', },
#     {'NAME': 'general.validators.LowercaseValidator', },
#     {'NAME': 'general.validators.SymbolValidator', },
# ]

OIDC_RP_CLIENT_ID = 'homeet.hse.ru'
OIDC_RP_CLIENT_SECRET = '7033d1c0-ed2e-4da3-bef4-7f941d7d78dc'
OIDC_OP_AUTHORIZATION_ENDPOINT = 'https://profile.miem.hse.ru/auth/realms/MIEM/protocol/openid-connect/auth'
OIDC_OP_TOKEN_ENDPOINT = 'https://profile.miem.hse.ru/auth/realms/MIEM/protocol/openid-connect/token'
OIDC_OP_USER_ENDPOINT = 'https://profile.miem.hse.ru/auth/realms/MIEM/protocol/openid-connect/userinfo'
OIDC_AUTHENTICATION_CALLBACK_URL = 'token-auth'
OIDC_OP_LOGOUT_URL_METHOD = 'general.utils.util.logout_redirect_uri'
OIDC_STORE_ID_TOKEN = True
OIDC_USE_NONCE = False


# Internationalization
# https://docs.djangoproject.com/en/3.2/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True

# EMAIL
EMAIL_BACKEND = 'django.core.mail.backends.smtp.EmailBackend'
EMAIL_HOST = 'smtp.hse.ru'
EMAIL_HOST_USER = 'homeet'
EMAIL_HOST_PASSWORD = 'v72Y65Dn'
EMAIL_PORT = 587
EMAIL_USE_TLS = True
EMAIL_USE_SSL = False
SERVER_EMAIL = 'homeet@hse.ru'
DEFAULT_FROM_EMAIL = 'homeet@hse.ru'

# Telegram bot
TELEGRAM = {
    'bot_token': '2123237112:AAGBNd4ncuCAikg7ln-gfa1vwMcKyOG4GDI',
    'channel_name': 'HomeetChannel',
}

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.2/howto/static-files/

STATIC_URL = '/static/'
DATA_UPLOAD_MAX_MEMORY_SIZE = 10*1024*1024*1024

# Default primary key field type
# https://docs.djangoproject.com/en/3.2/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'

MEDIA_URL = '/media/'
MEDIA_ROOT = os.path.join(BASE_DIR, 'media')

LOGIN_REDIRECT_URL = 'all-announcement'
LOGIN_URL = 'up'
STATIC_ROOT = os.path.join(BASE_DIR, 'static/')
